/**
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/**
 * Autogenerated by Thrift Compiler (0.9.3)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.apache.airavata.model.parallelism;


import java.util.Map;
import java.util.HashMap;
import org.apache.thrift.TEnum;

/**
 * Enumeration of application parallelism supported by Airavata
 * 
 * SERIAL:
 *  Single processor applications without any parallelization.
 * 
 * MPI:
 *  Messaging Passing Interface.
 * 
 * OPENMP:
 *  Shared Memory Implementtaion.
 * 
 * OPENMP_MPI:
 *  Hybrid Applications.
 * 
 */
public enum ApplicationParallelismType implements org.apache.thrift.TEnum {
  SERIAL(0),
  MPI(1),
  OPENMP(2),
  OPENMP_MPI(3),
  CCM(4),
  CRAY_MPI(5);

  private final int value;

  private ApplicationParallelismType(int value) {
    this.value = value;
  }

  /**
   * Get the integer value of this enum value, as defined in the Thrift IDL.
   */
  public int getValue() {
    return value;
  }

  /**
   * Find a the enum type by its integer value, as defined in the Thrift IDL.
   * @return null if the value is not found.
   */
  public static ApplicationParallelismType findByValue(int value) { 
    switch (value) {
      case 0:
        return SERIAL;
      case 1:
        return MPI;
      case 2:
        return OPENMP;
      case 3:
        return OPENMP_MPI;
      case 4:
        return CCM;
      case 5:
        return CRAY_MPI;
      default:
        return null;
    }
  }
}
